//*****************************************************************************
//* Copyright (c) 2004 Miday Workshop All rights reserved.
//*
//* File: SpotData.c
//*****************************************************************************

#include <windows.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <string.h>
#include <malloc.h>
#include <memory.h>
#include <sys/stat.h>
#include "SpotData.h"

//#define DLL_EXPORT __declspec( dllexport )     //delete 2005/03/31

typedef struct hol {
	int year;
	int month;
	int data[20];
} HOLIDAY;

int fd1, count, update_flag, update_proc;
int open_flag=0;
int version, rec_no[4], color_no;
int st_year, st_month, en_year, en_month;
HOLIDAY *holiday;
unsigned char *color_buff;
unsigned char header[76];
char filename[500], filename_back[500];

//---------------------------------------------------------------------------
long GetFilesize(char *file_name) {
//Get File length.  (local function)
	HANDLE fd;
	int len;
	fd = CreateFile(file_name,0/*GENERIC_READ*/,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL);	//Windows API
	if (fd==INVALID_HANDLE_VALUE) {
		return -1;
	}
	len = GetFileSize(fd, 0);		//Windows API
	CloseHandle(fd);				//Windows API
	return len;
}

//---------------------------------------------------------------------------
int GetToday(char *date) {
//Creation time is set up.  (local function)
	int yyyy, mm, dd, ia;
	int mon_date[12] = { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 };

	SYSTEMTIME st;
	GetLocalTime(&st);		//Windows API
	ia   = - (1904 * 365 + 1903 / 4);
	yyyy = st.wYear;
	mm   = st.wMonth;
	dd   = st.wDay;
	ia   = ia + yyyy * 365 + mon_date[mm-1] + dd;
	ia   = ia + (yyyy-1) / 4;
	if ( yyyy / 4 * 4 == yyyy && mm > 2 ) ia = ia + 1;
	ia   = ia * 24 * 60 * 60;
	ia   = ia + (((st.wHour*60)+st.wMinute)*60+st.wSecond);

	date[0] = ((ia & 0xff000000) >> 24);
	date[1] = ((ia & 0x00ff0000) >> 16);
	date[2] = ((ia & 0x0000ff00) >> 8);
	date[3] =  (ia & 0x000000ff);
	return 0;
}

//---------------------------------------------------------------------------
int FileRename() {
//file rename.  (local function)
	strcpy(filename_back, filename);
	strcat(filename_back, ".old");
	if ( CopyFile(filename, filename_back, FALSE) == FALSE ) return -1;		//Windows API     file copy API
	DeleteFile(filename);													//Windows API     file delete API
	return 0;
}


//---------------------------------------------------------------------------
int FileSave() {
//file update.  (local function)
	int ia, ib, ic, id, buff_pos2, rec_len, category, category_ar;
	unsigned char buff[300];

	//file rename
	if ( FileRename() != 0 ) return -3;

	//file open
	fd1 = open(filename, O_WRONLY|O_CREAT|O_BINARY, _S_IREAD|_S_IWRITE );
	if ( fd1 <= 0 ) {
		return -1;
	}

	//header write
	memcpy(buff, header, 76);
	GetToday(&buff[36]);
	memcpy(&buff[40], &buff[36], 4 );
	ia = write(fd1, buff, 76);
	if ( ia == -1 ) {
		return -2;
	}

	//record no write
	count   = rec_no[0] + rec_no[1] + rec_no[2] + rec_no[3];
	buff[0] = ((count & 0x0000ff00) >> 8);
	buff[1] =  (count & 0x000000ff);
	ia = write(fd1, buff, 2);

	buff_pos2 = 78 + count * 8 + 2;

	//index write
	category    = 1;
	category_ar = 0;
	for ( ib=0; ib<count; ib++ ) {
		switch ( category ) {
		case 1:
			rec_len = 2;
			break;
		case 2:
			rec_len = 8;
			break;
		case 3:
			rec_len = color_buff[1] + color_buff[0] * 256;
			break;
		case 4:
			rec_len = 4 + color_no * 4;
			break;
		}

		buff[0] = ((buff_pos2 & 0xff000000) >> 24);
		buff[1] = ((buff_pos2 & 0x00ff0000) >> 16);
		buff[2] = ((buff_pos2 & 0x0000ff00) >> 8);
		buff[3] =  (buff_pos2 & 0x000000ff);
		buff[4] = category;
		buff[5] = 0; buff[6] = 0; buff[7] = 0;
		ia = write(fd1, buff, 8);

		buff_pos2 = buff_pos2 + rec_len;

		category_ar++;
		if ( category_ar >= rec_no[category-1] ) {
			category_ar = 0;
			for (;;) {
				category++;
				if ( category == 4 ) {
					break;
				}
				if ( rec_no[category-1] != 0 ) {
					break;
				}
			}
		}
	}

	buff[0] = 0;
	buff[1] = 0;
	ia = write(fd1, buff, 2);

	//data write
	category    = 1;
	category_ar = 0;
	ic          = 0;
	for ( ib=0; ib<count; ib++ ) {
		switch ( category ) {
		case 1:
			buff[0] = ((version & 0x0000ff00) >> 8);
			buff[1] =  (version & 0x000000ff);
			write ( fd1, buff, 2);
			break;
		case 2:
			buff[0] = ((st_year & 0x0000ff00) >> 8);
			buff[1] =  (st_year & 0x000000ff);
			buff[2] = ((st_month & 0x0000ff00) >> 8);
			buff[3] =  (st_month & 0x000000ff);
			buff[4] = ((en_year & 0x0000ff00) >> 8);
			buff[5] =  (en_year & 0x000000ff);
			buff[6] = ((en_month & 0x0000ff00) >> 8);
			buff[7] =  (en_month & 0x000000ff);
			write ( fd1, buff, 8);
			break;
		case 3:
			write ( fd1, color_buff, color_buff[1] + color_buff[0] * 256);
			break;
		case 4:
			buff[0] = ((holiday[ic].year & 0x0000ff00) >> 8);
			buff[1] =  (holiday[ic].year & 0x000000ff);
			buff[2] = ((holiday[ic].month & 0x0000ff00) >> 8);
			buff[3] =  (holiday[ic].month & 0x000000ff);

			for (id=0; id<color_no; id++ ) {
				buff[id*4+4] = ((holiday[ic].data[id] & 0xff000000) >> 24);
				buff[id*4+5] = ((holiday[ic].data[id] & 0x00ff0000) >> 16);
				buff[id*4+6] = ((holiday[ic].data[id] & 0x0000ff00) >> 8);
				buff[id*4+7] =  (holiday[ic].data[id] & 0x000000ff);
			}
			write ( fd1, buff, color_no * 4 + 4);
			ic++;
			break;
		}

		category_ar++;
		if ( category_ar >= rec_no[category-1] ) {
			category_ar = 0;
			for (;;) {
				category++;
				if ( category == 4 ) {
					break;
				}
				if ( rec_no[category-1] != 0 ) {
					break;
				}
			}
		}
	}

	//file close
	close(fd1);

	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotOpen(char *filename_arg, int open_flag_arg) {
	int ia, ib;
	int buff_pos, buff_pos2;
	int len, brk_flag;
	unsigned char *buff;

	if ( open_flag == 1 ) return -4;
	if ( open_flag_arg != 0 && open_flag_arg != 1 ) return -9;

	//initialization
	memset(rec_no, 0, sizeof(rec_no));
	color_no    = 0;
	update_proc = 0;
	update_flag = open_flag_arg;
	open_flag   = 1;
	st_year     = 9999;
	st_month    = 12;
	en_year     = 0;
	en_month    = 1;

	strcpy(filename, filename_arg);

	//file size get
	len = GetFilesize(filename_arg);
	if ( len <= 0 ) {
		return -5;
	}
	buff = malloc(len);

	//data input
	fd1 = open(filename_arg, O_RDONLY|O_BINARY);
	if ( fd1 <= 0 ) {
		return -5;
	}
	ia = read(fd1, buff, len);
	if ( ia == -1 ) {
		return -6;
	}
	close(fd1);

	//header data
	memcpy(header, buff, 76);

	//record number
	count = buff[76] * 256 + buff[77];

	brk_flag = 0;
	for ( ia=0; ia<count; ia++ ) {
		buff_pos  = ia*8 + 78;
		buff_pos2 = buff[buff_pos+3] + buff[buff_pos+2] * 256
		          + buff[buff_pos+1] * 65536 + buff[buff_pos] * 16777216;
		switch((buff[buff_pos+4] & 0x0f)) {//category
		case 1:  //version
			rec_no[0]++;
			version = buff[buff_pos2+1] + buff[buff_pos2] * 256;
			brk_flag++;
			break;
		case 2:  //limit
			rec_no[1]++;
//			st_year  = buff[buff_pos2+1] + buff[buff_pos2] * 256;
//			st_month = buff[buff_pos2+3] + buff[buff_pos2+2] * 256;
//			en_year  = buff[buff_pos2+5] + buff[buff_pos2+4] * 256;
//			en_month = buff[buff_pos2+7] + buff[buff_pos2+6] * 256;
			break;
		case 3:  //color code
			rec_no[2]++;
			color_no   = buff[buff_pos2+3] + buff[buff_pos2+2] * 256;
			color_buff = malloc(buff[buff_pos2+1] + buff[buff_pos2] * 256);
			memcpy(color_buff, &buff[buff_pos2], buff[buff_pos2+1] + buff[buff_pos2] * 256);
			break;
		}
		if ( brk_flag == 2 ) break;
	}

	holiday = malloc((count-brk_flag)*88);

	for ( ia=0; ia<count; ia++ ) {
		buff_pos  = ia*8 + 78;
		buff_pos2 = buff[buff_pos+3] + buff[buff_pos+2] * 256
		          + buff[buff_pos+1] * 65536 + buff[buff_pos] * 16777216;
		switch((buff[buff_pos+4] & 0x0f)) {
		case 4:  //holiday data
			holiday[rec_no[3]].year  = buff[buff_pos2+1] + buff[buff_pos2] * 256;
			holiday[rec_no[3]].month = buff[buff_pos2+3] + buff[buff_pos2+2] * 256;

			if ( holiday[rec_no[3]].year < st_year || ( holiday[rec_no[3]].year == st_year && holiday[rec_no[3]].month < st_month )) {
				st_year  = holiday[rec_no[3]].year;
				st_month = holiday[rec_no[3]].month;
			}
			if ( holiday[rec_no[3]].year > en_year || ( holiday[rec_no[3]].year == en_year && holiday[rec_no[3]].month > en_month )) {
				en_year  = holiday[rec_no[3]].year;
				en_month = holiday[rec_no[3]].month;
			}

			for (ib=0; ib<color_no; ib++ ) {
				holiday[rec_no[3]].data[ib] = buff[buff_pos2+ib*4+7] + buff[buff_pos2+ib*4+6] * 256
				                            + buff[buff_pos2+ib*4+5] * 65536 + buff[buff_pos2+ib*4+4] * 16777216;
			}
			rec_no[3]++;
			break;
		}
	}

	free(buff);

	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotClose(int update_flag_arg) {
	int ix;

	ix = 0;
	if ( open_flag != 1 ) return -1;
	if ( update_flag_arg == 1 && update_proc == 1 ) {
		ix = FileSave();
	}

	free(holiday);
	if ( rec_no[2] == 1 ) {
		free(color_buff);
	}

	open_flag = 0;

	if ( update_flag_arg != 0 && update_flag_arg != 1 ) return -9;
	if ( ix  != 0 ) return -5;
	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotVersion(int *version_arg) {
	if ( open_flag != 1 ) return -1;
	*version_arg = version;
	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotCount(int *month_no_arg, int *color_no_arg) {
	if ( open_flag != 1 ) return -1;
	*month_no_arg = rec_no[3];
	*color_no_arg = color_no;
	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotLimit(int *st_year_arg, int *st_month_arg, int *en_year_arg, int *en_month_arg) {
	if ( open_flag != 1 ) return -1;
	*st_year_arg  = st_year;
	*st_month_arg = st_month;
	*en_year_arg  = en_year;
	*en_month_arg = en_month;
	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotColorGet(int *dev_flag_arg, HOL_COLOR *color_data_arg) {
	int char_len;
	char char_data[256];
	int ib, ic;

	if ( open_flag != 1 ) return -1;
	if ( rec_no[2] != 1 ) return -2;

	*dev_flag_arg = color_buff[5] + color_buff[4] * 256;
	for (ib=0; ib<color_no; ib++ ) {
		color_data_arg[ib].code          = color_buff[ib*24+7] + color_buff[ib*24+6] * 256;
		color_data_arg[ib].hol_flag      = color_buff[ib*24+9] + color_buff[ib*24+8] * 256;

		color_data_arg[ib].col1_back     = color_buff[ib*24+10];
		color_data_arg[ib].col1_text     = color_buff[ib*24+11];
		color_data_arg[ib].col2_back     = color_buff[ib*24+12];
		color_data_arg[ib].col2_text     = color_buff[ib*24+13];
		
		color_data_arg[ib].col1_back_rgb = color_buff[ib*24+17] + color_buff[ib*24+16] * 256
		                                 + color_buff[ib*24+15] * 65536 + color_buff[ib*24+14] * 16777216;
		color_data_arg[ib].col1_text_rgb = color_buff[ib*24+21] + color_buff[ib*24+20] * 256
		                                 + color_buff[ib*24+19] * 65536 + color_buff[ib*24+18] * 16777216;
		color_data_arg[ib].col2_back_rgb = color_buff[ib*24+25] + color_buff[ib*24+24] * 256
		                                 + color_buff[ib*24+23] * 65536 + color_buff[ib*24+22] * 16777216;
		color_data_arg[ib].col2_text_rgb = color_buff[ib*24+29] + color_buff[ib*24+28] * 256
		                                 + color_buff[ib*24+27] * 65536 + color_buff[ib*24+26] * 16777216;
	}

	ic = color_no*24+6;
	for (ib=0; ib<color_no; ib++ ) {
		char_len = color_buff[ic];
		strncpy(char_data, &color_buff[ic+1], char_len );
		char_data[char_len] = '\0';
		ic = ic + char_len + 1;
		strcpy(&color_data_arg[ib].text[0], char_data);
	}
	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotColorSet(int dev_flag_arg, int color_no_arg, HOL_COLOR *color_data_arg) {
	int char_len;
	int ia, ib, ic;

	if ( open_flag != 1 ) return -1;
//	if ( rec_no[2] != 1 ) return -2;
	if ( update_flag == 0 ) return -3;
	for (ib=0; ib<color_no_arg; ib++ ) {
		if ( strlen(&color_data_arg[ib].text[0]) > 256 ) return -9;
	}

	if ( color_no < color_no_arg ) {
		for (ia=0; ia<rec_no[3]; ia++ ) {
			for (ib=color_no; ib<color_no_arg; ib++ ) {
				holiday[ia].data[ib] = 0;
			}
		}
	}
	color_no = color_no_arg;

	ic = color_no*24+6;
	for (ib=0; ib<color_no; ib++ ) {
		char_len = strlen(&color_data_arg[ib].text[0]);
		ic = ic + char_len + 1;
	}
	if ( rec_no[2] == 1 ) {
		free(color_buff);
	}
	rec_no[2]  = 1;
	color_buff = malloc(ic);

	color_buff[0] = ((ic & 0x0000ff00) >> 8);
	color_buff[1] =  (ic & 0x000000ff);

	color_buff[2] = ((color_no_arg & 0x0000ff00) >> 8);
	color_buff[3] =  (color_no_arg & 0x000000ff);

	color_buff[4] = ((dev_flag_arg & 0x0000ff00) >> 8);
	color_buff[5] =  (dev_flag_arg & 0x000000ff);
	for (ib=0; ib<color_no_arg; ib++ ) {
		color_buff[ib*24+6] = ((color_data_arg[ib].code & 0x0000ff00) >> 8);
		color_buff[ib*24+7] =  (color_data_arg[ib].code & 0x000000ff);
		color_buff[ib*24+8] = ((color_data_arg[ib].hol_flag & 0x0000ff00) >> 8);
		color_buff[ib*24+9] =  (color_data_arg[ib].hol_flag & 0x000000ff);

		color_buff[ib*24+10] = color_data_arg[ib].col1_back;
		color_buff[ib*24+11] = color_data_arg[ib].col1_text;
		color_buff[ib*24+12] = color_data_arg[ib].col2_back;
		color_buff[ib*24+13] = color_data_arg[ib].col2_text;
		
		color_buff[ib*24+14] = ((color_data_arg[ib].col1_back_rgb & 0xff000000) >> 24);
		color_buff[ib*24+15] = ((color_data_arg[ib].col1_back_rgb & 0x00ff0000) >> 16);
		color_buff[ib*24+16] = ((color_data_arg[ib].col1_back_rgb & 0x0000ff00) >> 8);
		color_buff[ib*24+17] =  (color_data_arg[ib].col1_back_rgb & 0x000000ff);

		color_buff[ib*24+18] = ((color_data_arg[ib].col1_text_rgb & 0xff000000) >> 24);
		color_buff[ib*24+19] = ((color_data_arg[ib].col1_text_rgb & 0x00ff0000) >> 16);
		color_buff[ib*24+20] = ((color_data_arg[ib].col1_text_rgb & 0x0000ff00) >> 8);
		color_buff[ib*24+21] =  (color_data_arg[ib].col1_text_rgb & 0x000000ff);

		color_buff[ib*24+22] = ((color_data_arg[ib].col2_back_rgb & 0xff000000) >> 24);
		color_buff[ib*24+23] = ((color_data_arg[ib].col2_back_rgb & 0x00ff0000) >> 16);
		color_buff[ib*24+24] = ((color_data_arg[ib].col2_back_rgb & 0x0000ff00) >> 8);
		color_buff[ib*24+25] =  (color_data_arg[ib].col2_back_rgb & 0x000000ff);

		color_buff[ib*24+26] = ((color_data_arg[ib].col2_text_rgb & 0xff000000) >> 24);
		color_buff[ib*24+27] = ((color_data_arg[ib].col2_text_rgb & 0x00ff0000) >> 16);
		color_buff[ib*24+28] = ((color_data_arg[ib].col2_text_rgb & 0x0000ff00) >> 8);
		color_buff[ib*24+29] =  (color_data_arg[ib].col2_text_rgb & 0x000000ff);
		
	}

	ic = color_no*24+6;
	for (ib=0; ib<color_no; ib++ ) {
		char_len = strlen(&color_data_arg[ib].text[0]);
		color_buff[ic] = char_len;
		strncpy(&color_buff[ic+1], &color_data_arg[ib].text[0], char_len );
		ic = ic + char_len + 1;
	}

	update_proc = 1;
	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotDataGet(int year_arg, int month_arg, int *data_arg) {
	int ia, ib;

	if ( open_flag != 1 ) return -1;
	if ( month_arg < 1 || month_arg > 12 ) return -8;

	for (ib=0; ib<color_no; ib++ ) {
		data_arg[ib] = 0;
	}

	for (ia=0; ia<rec_no[3]; ia++ ) {
		if ( year_arg == holiday[ia].year && month_arg == holiday[ia].month ) {
			for (ib=0; ib<color_no; ib++ ) {
				data_arg[ib] = holiday[ia].data[ib];
			}
			break;
		}
	}
	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotDataSet(int year_arg, int month_arg, int *data_arg) {
	int ia, ib, ic, id;

	if ( open_flag != 1 ) return -1;
	if ( update_flag == 0 ) return -3;
	if ( month_arg < 1 || month_arg > 12 ) return -8;
	id = 0;
	for (ib=0; ib<color_no; ib++ ) {
		if ( data_arg[ib] != 0 ) {
			id = 1;
			break;
		}
	}
	if ( id == 0 ) return -7;

	ic = 0;
	for (ia=0; ia<rec_no[3]; ia++ ) {
		if ( year_arg == holiday[ia].year && month_arg == holiday[ia].month ) {
			for (ib=0; ib<color_no; ib++ ) {
				holiday[ia].data[ib] = data_arg[ib];
			}
			ic = 1;
			break;
		}
	}

	if ( ic == 0 ) {
		holiday = realloc(holiday, (rec_no[3]+1)*88);
		for (ib=0; ib<color_no; ib++ ) {
			holiday[rec_no[3]].data[ib] = data_arg[ib];
		}
		holiday[rec_no[3]].year  = year_arg;
		holiday[rec_no[3]].month = month_arg;
		rec_no[3]++;

		if ( year_arg < st_year || ( year_arg == st_year && month_arg < st_month )) {
			st_year  = year_arg;
			st_month = month_arg;
		}
		if ( year_arg > en_year || ( year_arg == en_year && month_arg > en_month )) {
			en_year  = year_arg;
			en_month = month_arg;
		}
	}

	update_proc = 1;
	return 0;
}

//---------------------------------------------------------------------------
DLL_EXPORT int STDCALL SpotDataDelete(int year_arg, int month_arg) {
	int ia, ib;

	if ( open_flag != 1 ) return -1;
	if ( update_flag == 0 ) return -3;
	if ( month_arg < 1 || month_arg > 12 ) return -8;

	for (ia=0; ia<rec_no[3]; ia++ ) {
		if ( year_arg == holiday[ia].year && month_arg == holiday[ia].month ) {
			if ( ia != rec_no[3]-1 ) {
				for (ib=0; ib<color_no; ib++ ) {
					holiday[ia].data[ib] = holiday[rec_no[3]-1].data[ib];
				}
				holiday[ia].year  = holiday[rec_no[3]-1].year;
				holiday[ia].month = holiday[rec_no[3]-1].month;
			}
			rec_no[3]--;
			break;
		}
	}

	update_proc = 1;
	return 0;
}
